<template>
  <div style="padding: 20px">
    <h1>Создание отзыва</h1>
    <form>
      <label>Текст отзыва:</label>
      <textarea v-model="text"></textarea>

      <label>Преподаватель:</label>
      <select v-model="tutorId">
        <option
          v-for="option in tutors"
          v-bind:value="option.value"
          v-bind:key="option.value"
        >
          {{ option.text }}
        </option>
      </select>

      <label>Предмет: </label>
      <select v-model="courseId">
        <option
          v-for="option in courses"
          v-bind:value="option.value"
          v-bind:key="option.value"
        >
          {{ option.text }}
        </option>
      </select>

      <label>На сколько баллов вы оцениваете преподавателя/предмет *:</label>
      <select v-model="score" required="required">
        <option
          v-for="option in scores"
          v-bind:value="option.value"
          v-bind:key="option.value"
        >
          {{ option.text }}
        </option>
      </select>

      <label>Год начала обучения:</label>
      <input
        required="required"
        v-model="eduStart"
        type="number"
        min="2010"
        max="2050"
        maxlength="4"
      />

      <label>Год окончания обучения:</label>
      <input
        v-model="eduEnd"
        required="required"
        type="number"
        min="2010"
        max="2050"
        maxlength="4"
      />

      <label>Никнейм (опционально):</label>
      <input v-model="nickname" type="text" />
      <div style="">
        <div style="float: left">
          <vue-recaptcha
            ref="recaptcha"
            sitekey="6LdVmhkeAAAAAOEHvP8rTYKVmiVcTtbTMbT_Y7Mp"
            :load-recaptcha-script="true"
            @verify="onCaptchaVerified"
            @expired="onCaptchaExpired"
          />
        </div>
        <div style="padding: 29px; float: left">
          <span style="color: red"> {{ errorText }}</span>
        </div>
      </div>
      <button @click="sendReview">Отправить</button>
    </form>
  </div>
</template>

<script>
import axios from "axios";
import moment from "moment";

export default {
  name: "CreateReview.vue",
  data() {
    let array = [
      { value: 1, text: "1" },
      { value: 2, text: "2" },
      { value: 3, text: "3" },
      { value: 4, text: "4" },
      { value: 5, text: "5" },
      { value: 6, text: "6" },
      { value: 7, text: "7" },
      { value: 8, text: "8" },
      { value: 9, text: "9" },
      { value: 10, text: "10" },
    ];
    return {
      tutors: [],
      courses: [],
      scores: [...array],
      text: "",
      tutorId: null,
      courseId: null,
      score: null,
      nickname: null,
      loading: false,
      eduStart: null,
      eduEnd: null,
      tutorsFull: [],
      sitekey: process.env.CAPTCHA_SITECODE,
      url: String(process.env.VUE_APP_API_URL),
      token: null,
      doCaptchaVisible: false,
      errorText: "",
    };
  },
  methods: {
    formatTutor(tutor) {
      return (
        tutor.lastName +
        " " +
        tutor.firstName.charAt(0) +
        ". " +
        tutor.patronymic.charAt(0) +
        ". "
      );
    },
    acceptTutorsList(response) {
      this.tutorsFull = response.data.tutorsList;
      this.tutors = response.data.tutorList.map((tutor) => ({
        text: this.formatTutor(tutor),
        value: tutor.tutorId,
        ...tutor,
      }));
    },
    acceptCoursesList(response) {
      this.courses = response.data.courseList.map((course) => ({
        text: course.courseName,
        value: course.courseId,
        ...course,
      }));
    },
    sendReview(e) {
      if (this.tutorId == null && this.courseId == null) {
        this.errorText = "Укажите преподавателя и (или) спецкурс";
        e.preventDefault();
        return;
      }
      if (!this.score || !this.eduEnd || !this.eduStart) {
        this.errorText = "Заполните обязательные поля";
        e.preventDefault();
        return;
      }
      if (this.token == null) {
        this.errorText = "Поддвердите что вы не робот";
        e.preventDefault();
        return;
      }
      e.preventDefault();
      this.errorText = "";
      axios.post(this.url + "review", {
        review: {
          tutor: this.tutors.find((tutor) => tutor.tutorId === this.tutorId),
          course: this.courses.find((course) => course.value === this.courseId),
          nickname: this.nickname,
          text: this.text,
          score: this.score,
          eduStart: this.eduStart,
          eduEnd: this.eduEnd,
          reviewDate: moment(String(new Date)).format("yyyy-MM-DD"),
        },
        recaptchaToken: this.token,
      });
      this.onCaptchaExpired();
    },
    onCaptchaExpired() {
      this.token = null;
      this.$refs.recaptcha.reset();
    },
    onCaptchaVerified(token) {
      this.errorText = "";
      this.token = token;
    },
  },
  mounted() {
    axios.get(this.url + "tutor").then(this.acceptTutorsList);
    axios.get(this.url + "course").then(this.acceptCoursesList);
  },
};
</script>

<style scoped>
input,
textarea,
select {
  width: 100%;
  padding: 5px;
  border: 1px solid #ccc;
  border-radius: 5px;
  margin-bottom: 10px;
  display: block;
  box-sizing: border-box;
}

textarea {
  height: 150px;
}

label {
  font-size: small;
  margin-top: 10px;
  margin-bottom: 10px;
}

button {
  width: 100%;
}
</style>
